<?php
//
//	Module name      :	odbccfgutil.php
//	Version          :	1.0
//	Started on       :	April 29, 2005
//	Completed on     :	Maj 10, 2005
//
//	Module type      :	Library
//	Description      :	Utility functions based on OdbcCfg module
//
//	Developed under  :	Php 4.1.2
//	Sw requirements  :	None
//
//	Parameters       :	None
//	Notes - usage    :	All functions works on configuration descriptor of OdbcCfg module.
//						Functions OCUTsl and OCUUnlock works on the section name "Locks"; this can be
//						changed using $OCU_lock_sec_name.
//


//--- Include files --------------------------------------------------------------------------------



require_once("odbccfg.php");
require_once("dateutil.php");



//--- Public constants -----------------------------------------------------------------------------



define("OCU_MODULE_NAME", "odbccfgutil.php 1.0; on Maj 10, 2005 by J.Hubb.");

// Timeout disabled in OCUTsl function
define("OCU_NO_TIMEOUT",	0);



//--- Public variables -----------------------------------------------------------------------------



$OCU_lock_sec_name  = "Locks";



//--- Private constants ----------------------------------------------------------------------------



//--- Private variables ----------------------------------------------------------------------------



//--- Public functions code ------------------------------------------------------------------------



function OCUUnlock(&$cfg_desc, $var)
// Clear the lock on variable $var in section "Locks" (see $OCU_lock_sec_name) of the configuration descriptor
// $cfg_desc. Returns nothing.
{
	global $OCU_lock_sec_name;

	ODBCQuery($cfg_desc["_DbDesc"], "UPDATE $cfg_desc[CfgTableName] SET $cfg_desc[ValFieldName] = 0 " .
			"WHERE $cfg_desc[SecFieldName] = '$OCU_lock_sec_name' AND $cfg_desc[VarFieldName] = '" .
			addslashes($var) . "'");
	return;
}



function OCUTsl(&$cfg_desc, $var, $timeout = OCU_NO_TIMEOUT)
// Test and set lock; works using the configuration descriptor $cfg_desc, on the boolean value (0/1) of
// the variable $var in section "Locks" (see $OCU_lock_sec_name). Returns TRUE on lock acquired, FALSE if
// $timeout is specified (in seconds with microseconds resolution) and it is expired (lock not acquired); it
// does not return if $timeout is not specified.
{
	global $OCU_lock_sec_name;

	$within_timeout = TRUE;
	$tmp_name = $cfg_desc["CfgTableName"] . $OCU_lock_sec_name . $var;
	DUTimerReset($tmp_name);
	do
	{
		DUTimerReset($tmp_name . "Query");
		ODBCQuery($cfg_desc["_DbDesc"], "UPDATE $cfg_desc[CfgTableName] SET $cfg_desc[ValFieldName] = 1 " .
				"WHERE $cfg_desc[SecFieldName] = '$OCU_lock_sec_name' AND $cfg_desc[VarFieldName] = '" .
				addslashes($var) . "'");
		$delay = DUTimerRead($tmp_name . "Query") * 10000000;
		$lock_get = ODBCAffectedRows($cfg_desc["_DbDesc"]);
		if ($lock_get != 1)
		{
			usleep($delay);
			if (($timeout != OCU_NO_TIMEOUT) && (DUTimerRead($tmp_name) >= $timeout))
			{
				$within_timeout = FALSE;
				$lock_get = 1;
			}
		}
	} while ($lock_get != 1);
	return $within_timeout;
}



//--- Private functions code -----------------------------------------------------------------------



//--- Initialization code --------------------------------------------------------------------------



?>
